/**
 * Ajax Error Logger
 *
 * @author M.Uttula
 * @version 2006/04/11 - v0.1 - (M.Uttula) Initial revision
 */
<?php
	define('_AEL_SCRIPT_URL', 'ael.php');
	define('_AEL_SUPPRESS_DEFAULT_HANDLER', false); // Some browsers don't care about this... and on my opinion, it should always be false. YMMV.
	define('_AEL_MSG_VAR', 'ael_msg');
	define('_AEL_URL_VAR', 'ael_url');
	define('_AEL_LNO_VAR', 'ael_lno');
	
	if (
		isset($_GET[_AEL_MSG_VAR])
		|| 
		isset($_GET[_AEL_URL_VAR])
		|| 
		isset($_GET[_AEL_LNO_VAR])
	) {
		$msg = isset($_GET[_AEL_MSG_VAR]) ? $_GET[_AEL_MSG_VAR] : 'NO MESSAGE';
		$url = isset($_GET[_AEL_MSG_VAR]) ? $_GET[_AEL_URL_VAR] : 'NO URL';
		$lno = isset($_GET[_AEL_MSG_VAR]) ? $_GET[_AEL_LNO_VAR] : 'NO LINE NUMBER';
		// Here, we can do the logging... to database, flat file, server log, wherever... it's your choice - and yours to implement :)
		trigger_error('     JavaScript Error ("'.$msg.'") logged @ line '.$lno.' of '.$url.'     ', E_USER_ERROR); // This is just an example...
	} else {
?>
window.onerror = function (msg, url, lno) {
	var ajax;
	if (window.XMLHttpRequest) {
		try {
			ajax = new window.XMLHttpRequest(); // XMLHttpRequest (Mozilla, Opera, Safari, etc.)
		} catch (e) {
			ajax = false;
		}
	} else {
		var msXML = new Array( // XMLHttpRequest (IE with ActiveX)
			"Msxml2.XMLHTTP.5.0",
			"Msxml2.XMLHTTP.4.0",
			"Msxml2.XMLHTTP.3.0",
			"Msxml2.XMLHTTP",
			"Microsoft.XMLHTTP"
		);
		for (var i = 0; i < msXML.length; i++) { // We want to get the best we can
			try {
				ajax = new ActiveXObject(msXML[i]);
				window.status=i;
				break;
			} catch (e) {
				ajax = false;
			}
		}
	}
	if (ajax) {
		var data = "";
		data += ((data != "") ? "&" : "") + encodeURIComponent('<?php echo(_AEL_MSG_VAR); ?>') + "=" + encodeURIComponent(msg);
		data += ((data != "") ? "&" : "") + encodeURIComponent('<?php echo(_AEL_URL_VAR); ?>') + "=" + encodeURIComponent(url);
		data += ((data != "") ? "&" : "") + encodeURIComponent('<?php echo(_AEL_LNO_VAR); ?>') + "=" + encodeURIComponent(lno);
		data = '<?php echo(_AEL_SCRIPT_URL) ?>?' + data;
		ajax.open('GET', data, true);
		ajax.send(null);
	}
	return <?php (_AEL_SUPPRESS_DEFAULT_HANDLER ? 'true' : 'false') ?>;
}
<?php
	}
?>